/**
 * Created by Thaylin Burns ©2009 for Flash Coders NY http://flashcodersny.org
 * Visit my blog for more actionscript tips at http://thaylin.info/blog 
 */
package org.flashCodersNY.thaylin
{
	import flash.external.ExternalInterface;
	
	public class Example2_AddCallback
	{
		public function Example2_AddCallback()
		{
		}
		public function start():void
		{
		/**
		* NOW THAT WE'VE SEEN EXTERNAL INTERFACE LET'S SEE WHAT WE CAN DO WITH JAVASCRIPT CALLING FLASH
		* swfobject.getObjectById("flash_flash") is used below to retrieve the flash based on the id that was set when we embedded the swf
		* swfobject comes with this getObjectById() built in to do just as it states: retrieve objects based on the id
		*/
		var callBackJS:XML = 
		<script>
			<![CDATA[
						function()
						{
							// FIRST WE NEED TO SEE IF OUR FCNY OBJECT IS SET. THIS IS AN OBJECT THAT WE'LL SET UP TO BE ACCESSED GLOBALLY IN THE BROWSER
							// IF THE OBJECT IS NOT AVAILABLE WE CREATE A NEW PERSISTENT OBJECT BY NOT USING THE var KEYWORD AS WE'LL FIND OUT A LITTLE LOWER
							if(!window.FCNY)
							{
								FCNY = new Object();
							}
							//SECOND WE NEED TO KNOW WHAT THE FLASH OBJECT IS TO ADD OUR METHOD CALLS
							// THIS ID IS SET IN THE SWF OBJECT CODE WITH A PARAMETER THAT'S PASSED AS
							// var attributes = {id: "flash_flash"};
							// WHICH IS THEN PASSED INTO THE SWFOBJECT
							
							FCNY.flashObj = swfobject.getObjectById('flash_flash');
							
							
							// NOW WE SET A TIMEOUT IN THE JS TO CALL THE timedOut() METHOD
							//setTimeout(timedOut, 1000);
							
							function timedOut()
							{
								FCNY.flashObj.traceMe('hi');
								// IF WE WANT WE COULD EVEN USE THIS METHOD AS A TIMER INTERVAL TO CALL A FLASH METHOD AND UPDATE CODE OR AN OBJECT
								// LIKE IF THE PAGE'S TIMER IS SET TO MAYBE 1 MINUTE INTERVALS AND THAT'S TIED TO DATA FROM SOME SITE THAT UPDATES
								// CONTENT REGULARLY
								setTimeout(timedOut, 3000);
							}
						}
			]]>
		</script>
		// BELOW WE USE THE EXTERNALINTERFACE'S addCallback() METHOD TO LET FLASH KNOW THERE WILL BE SOMETHING EXTERNAL CALLING THIS METHOD OF traceMe()
		// WE THEN PASS IN THE METHOD WE WANT THE FLASH TO CALL WHEN IT "HEARS" THIS TRACEME METHOD WHICH WE'LL CALL heyTrace()
		ExternalInterface.addCallback("traceMe", heyTrace);
		// FINALLY WE MAKE A CALL VIA EXTERNALINTERFACE TO THE JAVASCRIPT SIDE AND INJECT THE ABOVE XML CODE WE CREATED.
		ExternalInterface.call(callBackJS);
		}
		
		private function heyTrace(value:String):void
		{
			trace(value)
		}
		/* 
		ANOTHER WAY YOU CAN CHECK TO SEE IF THIS METHOD IS WORKING IS TO NOT ADD THE TIMEOUT METHOD CALL AND SIMPLY CALL IT YOURSELF IN THE BROWSERS ADDRESS BAR
		THIS CAN BE ACCOMPLISHED (AND USED TO CALL ANY ACCESSIBLE JAVASCRIPT METHODS ON A BROWSER) BY USING THE FOLLOWING
		javascript:FCNY.timedOut() 
		YOU NEED TO CHANGE THE CODE A LITTLE BIT THOUGH SINCE AS THE STATE IT IS IN CURRENTLY THE METHOD TIMEDOUT() ISN'T A PERSISTENT METHOD AND WILL NOT BE ABLE TO BE CALLED.
		THUS THE FNCY ADDED TO THE METHOD CALL. SO THE CODE WOULD CHANGE TO LOOK LIKE THIS:
		
		FCNY.timedOut = function()
		{
			FCNY.flashObj.traceMe('hi')'
			setTimeout(FCNY.timedOut, 3000)
		} 
		*/
		
	}
}